import sbt._
import sbt.Keys.{resourceManaged, sourceManaged}

import scala.language.postfixOps
import java.io.File

object SourceGenerator {
  def generateVersionFile(major: SettingKey[String], minor: SettingKey[String], patch: SettingKey[String]): Def.Initialize[Task[Seq[File]]] = {
    Def.task {
      val file = (Compile / sourceManaged).value / "com" / "evernym" / "verity" / "version.scala"
      println("Generated version file: " + file)
      val contents = s"""// Generated by SBT
                        |// Do not edit!
                        |
                        |package com.evernym.verity
                        |
                        |case class AppVersion (major: String, minor: String, patch: String)
                        |
                        |object BuildInfo {
                        |  val version = AppVersion("${major.value}", "${minor.value}", "${patch.value}")
                        |}""".stripMargin
      IO.write(file, contents)
      Seq(file)
    }
  }

  def writeVerityVersionConf(version: SettingKey[String]): Def.Initialize[Task[Seq[File]]] = {
    Def.task {
      val file = resourceManaged.value / "verity-version.conf"
      println(s"Generated version conf file: ${file.getAbsoluteFile}")
      val contents = s"verity.version=${version.value}"
      IO.write(file, contents)
      Seq(file)
    }
  }

}
